﻿# -*- coding: utf-8 -*-

import sys, struct

#### =======================================================================
__all__ = ("ChunkObject", "ChunkKeyId", "ChunkIdKey")

#### =======================================================================
__FnStoId = struct.Struct(">L").unpack

def ChunkKeyId(name, srcObject):
	# key: str → key: id
	return(type(name, (ChunkObject,), dict([ (k, __FnStoId(v)[0]) for (k,v) in srcObject.items() ] + [("__slots__",tuple())])))

if(sys.version_info[0] >= 3):
	def ChunkIdKey(name, srcObject):
		# key: str → id: str
		return(type(name, (ChunkObject,), dict([ (__FnStoId(v)[0], v.decode()) for v in srcObject.values() ] + [("__slots__",tuple())])))
else:
	def ChunkIdKey(name, srcObject):
		# key: str → id: str
		return(type(name, (ChunkObject,), dict([ (__FnStoId(v)[0], str(v)) for v in srcObject.values() ] + [("__slots__",tuple())])))

#### =======================================================================
class _ChunkMetaObject(type):
	def __getitem__(cls, k):
		return(cls.__dict__[k])

# py2,3共用
#ChunkMetaObject = _ChunkMetaObject("ChunkObject", (object,), {})

#### ----------------
#class ChunkObject(object, metaclass=_ChunkMetaObject):	# py3
#	__metaclass__ = _ChunkMetaObject	# py2
class ChunkObject(_ChunkMetaObject("ChunkObject", (object,), {})):
	__slots__=()

	@classmethod
	def items(cls):
		return(tuple( (k, v) for (k, v) in cls.__dict__.items() if(isinstance(k, int) or (not k.endswith("__"))) ))
	@classmethod
	def keys(cls):
		return(tuple( k for (k, v) in cls.__dict__.items() if(isinstance(k, int) or (not k.endswith("__"))) ))
	@classmethod
	def values(cls):
		return(tuple( v for (k, v) in cls.__dict__.items() if(isinstance(k, int) or (not k.endswith("__"))) ))

	def __getitem__(self, k):	# obj[k]
		return(self.__class__.__dict__[k])
