﻿# -*- coding: utf-8 -*-

#### ========================================================================
__all__ = ("VMul", "VMulSub", "VMulAdd", "VSub", "VSubMul", "VAdd", "VAddMul", "VScl", "VTransform")

#### ========================================================================
def VMul(v0,v1):
	return([v0[0]*v1[0], v0[1]*v1[1], v0[2]*v1[2]])

def VMulSub(v0,v1,v2):
	return([(v0[0]*v1[0])-v2[0], (v0[1]*v1[1])-v2[1], (v0[2]*v1[2])-v2[2]])

def VMulAdd(v0,v1,v2):
	return(((v0[0]*v1[0])+v2[0], (v0[1]*v1[1])+v2[1], (v0[2]*v1[2])+v2[2]))

#### ------------------------------------------------------------------------
def VSub(v0,v1):
	return((v0[0]-v1[0], v0[1]-v1[1], v0[2]-v1[2]))

def VSubMul(v0,v1,v2):
	return(((v0[0]-v1[0])*v2[0], (v0[1]-v1[1])*v2[1], (v0[2]-v1[2])*v2[2]))

#### ------------------------------------------------------------------------
def VAdd(v0,v1):
	return((v0[0]+v1[0], v0[1]+v1[1], v0[2]+v1[2]))

def VAddMul(v0,v1,v2):
	return(((v0[0]+v1[0])*v2[0], (v0[1]+v1[1])*v2[1], (v0[2]+v1[2])*v2[2]))

#### ------------------------------------------------------------------------
def VScl(v0,v1):
	return([v0[0]*v1, v0[1]*v1, v0[2]*v1])

#### =======================================================================
def VTransform(v, m):
	# Blender用(m==[4][4]object)
	x = (m[0][0] * v[0]) + (m[1][0] * v[1]) + (m[2][0] * v[2]) + m[3][0]
	y = (m[0][1] * v[0]) + (m[1][1] * v[1]) + (m[2][1] * v[2]) + m[3][1]
	z = (m[0][2] * v[0]) + (m[1][2] * v[1]) + (m[2][2] * v[2]) + m[3][2]
	return((x,y,z))
