﻿# -*- coding: utf-8 -*-

from __future__ import absolute_import

import sys

from . import Chunk_Object

if(sys.modules["Load_LWO"].DO_RELOAD):
	if(sys.version_info[0] >= 3):
		import importlib
		Fn = importlib.reload
	else:
		Fn = reload
	loc = set(locals().keys())
	for f in ("Chunk_Object",):
		if(f in loc):
			Fn(eval(f))
	del f, loc

#### =======================================================================
__all__ = (
	"ReadT", "RSize",

	"TXPRJ", "TXBLN",

	"PolyIdT", "VMapIdT", "VMedIdT", "PTagIdT", "SurfIdT", "SBlokIdT", "BlokIdT", 
	"TxtrIdT", "ImgIdT", "ProcIdT", "GradIdT", "ShadIdT", "ClipIdT", "ChunkIdT", 

	"PolyNameT",
	"ClipNameT",
	)
#	"_PolyT", "_VMapT", "_VMedT", "_PTagT", "_SurfT", "_SBlokT", "_BlokT",
#	"_TxtrT", "_ImgT", "_ProcT", "_GradT", "_ShadT", "_ClipT", "_ChunkT",

#### =======================================================================
#### ポリゴンタイプ ----------------
class _PolyT(Chunk_Object.ChunkObject):
	FACE = b"FACE"	# 生ポリ
	CURV = b"CURV"	# カーブ
	PTCH = b"PTCH"	# サブパッチ
	MBAL = b"MBAL"	# メタボール
	BONE = b"BONE"	# スケルゴン
	SUBD = b"SUBD"	# CC SubD
	HBLD = b"HBLD"	# HairBlade
	__slots__=()

#### 頂点マップタイプ ----------------
class _VMapT(Chunk_Object.ChunkObject):
	WGHT = b"WGHT"	# ウェイト
	MORF = b"MORF"	# 相対モーフ
	SPOT = b"SPOT"	# 絶対モーフ
	TXUV = b"TXUV"	# UV
	RGB_ = b"RGB "	# 頂点カラー(RGB)
	RGBA = b"RGBA"	# 頂点カラー(RGBA)
	PICK = b"PICK"	# 選択セット
	MNVW = b"MNVW"	# 頂点ウェイト
	NORM = b"NORM"	# perPolPnt法線
	__slots__=()

#### Modo LWO ----------------
class _VMedT(Chunk_Object.ChunkObject):
	SUBV = b"SUBV"	# A subdivision edge weight map.
	EPCK = b"EPCK"	# A edge selection set map.
	__slots__=()

#### ポリゴンタグ ----------------
class _PTagT(Chunk_Object.ChunkObject):
	SURF = b"SURF"	# サーフェス名
	BONE = b"BONE"	# ボーン名
	BNWT = b"BNWT"	# ボーンウェイトマップ名
	BNUP = b"BNUP"	# スケルゴンupvector str".6f .6f .6f"
	PART = b"PART"	# グループパート名
	SMGP = b"SMGP"	# スムージンググループ
	COLR = b"COLR"	# UI表示色名
	APSL = b"APSL"	# SubD分割数
	NORM = b"NORM"	# 法線
	HBCA = b"HBCA"	# HairBlade
	HBCP = b"HBCP"	# HairBlade
	HBUV = b"HBUV"	# HairBlade
	HBRT = b"HBRT"	# HairBlade
	# SKELEGONEDITOR	"Created By SkelegonEditor"
	SKED = b"SKED"	# SKELEGONEDITOR
	SKON = b"SKON"	# ボーン名
	SKID = b"SKID"	# SkelegonEditor内 BoneId
	SKPR = b"SKPR"	# SkelegonEditor内 親BoneId
	SKCL = b"SKCL"	# スケッチカラーIdx
	SKBM = b"SKBM"	# バンクモード, enum 0:BNUP依存 1:無変更 2:+X 3:-X 4:+Y 5:-Y 6:+Z 7:-Z 8:任意値
	SKBR = b"SKBR"	# バンク値, str"radian .6f" SKBM:8
	# LW依存
	SKLA = b"SKLA"	# HPBコントロール 0:keyframe 1:taget 2:align 3:ik
	SKLH = b"SKLH"	# Head limits, Flag Min Max Stiffness, str"d .6f .6f .6f"
	SKLP = b"SKLP"	# Pitch
	SKLB = b"SKLB"	# Bank
	SKGL = b"SKGL"	# IKゴール名。"Goal_ボーン名"
	__slots__=()

#### サーフェス ----------------
class _SurfT(Chunk_Object.ChunkObject):
	COLR = b"COLR"	# カラー
	DIFF = b"DIFF"	# ディフューズ
	LUMI = b"LUMI"	# 自己発光
	SPEC = b"SPEC"	# スペキュラ
	REFL = b"REFL"	# 反射
	TRAN = b"TRAN"	# 透明度
	TRNL = b"TRNL"	# トランスルーセント
	GLOS = b"GLOS"	# グロス
	SHRP = b"SHRP"	# ディフューズシャープネス
	BUMP = b"BUMP"	# バンプ
	SIDE = b"SIDE"	# 両面
	SMAN = b"SMAN"	# スムース閾値
	VERS = b"VERS"	# 

	RFOP = b"RFOP" # -鏡面反射Opt
	RIMG = b"RIMG" # -鏡面反射Img
	RSAN = b"RSAN" # -画像継ぎ目位相
	RBLR = b"RBLR" # 反射のぼかし
	RIND = b"RIND" # 屈折Index
	TROP = b"TROP" # -屈折Opt
	TIMG = b"TIMG" # -屈折Img
	TBLR = b"TBLR" # 屈折のぼかし

	CLRS = b"CLRS" # -ハイライト色
	CLRF = b"CLRF" # -色フィルタ
	ADTR = b"ADTR" # -透明度の加算
	GLOW = b"GLOW" # -グロー
	LINE = b"LINE" # -アウトライン
	ALPH = b"ALPH" # -アルファチャネル

	VCOL = b"VCOL"	# 頂点カラーマップ名
	NORM = b"NORM"	# pntPerPol法線マップ名
	BLOK = b"BLOK"	# サーフェスブロック
	__slots__=()

#### 新サーフェス ----------------
# [FORM][size][LWO2][TAGS]...[FORM][size][SURF][    ]....
class _SBlokT(Chunk_Object.ChunkObject):
	SURF = b"SURF"	# FORM, 
	NAME = b"    "	# spc*4
	VERS = b"VERS"	# 
	CMNT = b"CMNT"	# Comment

	AOVS = b"AOVS"	# --FORM, SurfaceCustomAOVs
	AOVN = b"AOVN"	# SurfaceCustomAOVName

	NODS = b"NODS"	# --FORM, Nodes
	NROT = b"NROT"	# --FORM--FORM, Root
	NLOC = b"NLOC"	# Location
	NZOM = b"NZOM"	# Zoom
	NSTA = b"NSTA"	# Disabled

	NVER = b"NVER"	# NVER

	NNDS = b"NNDS"	# --FORM, Nodes
	NSRV = b"NSRV"	# Server
	NTAG = b"NTAG"	# --FORM--FORM, Tag
	NRNM = b"NRNM"	# RealName
	NNME = b"NNME"	# Name
	NCRD = b"NCRD"	# Coordinates
	NMOD = b"NMOD"	# Mode
	NDTA = b"NDTA"	# Data
	NPRW = b"NPRW"	# Preview
	NCOM = b"NCOM"	# Comment
	NPLA = b"NPLA"	# Placement

	NCON = b"NCON"	# --FORM, Connections
	INME = b"INME"	# NodeName
	IINM = b"IINM"	# InputName
	IINN = b"IINN"	# InputNodeName
	IONM = b"IONM"	# InputOutputName

	SSHA = b"SSHA"	# FORM, SurfaceShader
	SSHN = b"SSHN"	# SurfaceShaderName
	SSHD = b"SSHD"	# --FORM, SurfaceShaderData
	__slots__=()

#### ----------------
class _BlokT(Chunk_Object.ChunkObject):
	PROC = b"PROC"	# プロシージャル
	TMAP = b"TMAP"	# テクスチャマップ
	IMAP = b"IMAP"	# イメージマップ
	GRAD = b"GRAD"	# グラディエント
	SHDR = b"SHDR"	# プラグイン

	PROJ = b"PROJ"	# 
	AXIS = b"AXIS"	# ImgUV
	IMAG = b"IMAG"	# イメージ名
	WRAP = b"WRAP"	# 
	WRPW = b"WRPW"	# 
	WRPH = b"WRPH"	# 
	VMAP = b"VMAP"	# UV名
	AAST = b"AAST"	# 
	PIXB = b"PIXB"	# 
	STCK = b"STCK"	# 
	TAMP = b"TAMP"	# 
	__slots__=()

#### テクスチャ ----------------
class _TxtrT(Chunk_Object.ChunkObject):
	CNTR = b"CNTR"	# 
	SIZE = b"SIZE"	# 
	ROTA = b"ROTA"	# 
	OREF = b"OREF"	# 
	ROID = b"ROID"	# (3)
	FALL = b"FALL"	# 
	CSYS = b"CSYS"	# 
	__slots__=()

#### イメージ ----------------
class _ImgT(Chunk_Object.ChunkObject):
	CHAN = b"CHAN"	# 
	ENAB = b"ENAB"	# 
	OPAC = b"OPAC"	# 
	AXIS = b"AXIS"	# 
	NEGA = b"NEGA"	# 
	__slots__=()

#### プロシージャル ----------------
class _ProcT(Chunk_Object.ChunkObject):
	AXIS = b"AXIS"	# 
	VALU = b"VALU"	# 
	FUNC = b"FUNC"	# 
	__slots__=()

#### グラディエント ----------------
class _GradT(Chunk_Object.ChunkObject):
	PNAM = b"PNAM"	# 
	INAM = b"INAM"	# 
	GRST = b"GRST"	# 
	GREN = b"GREN"	# 
	GRPT = b"GRPT"	# 
	FKEY = b"FKEY"	# 
	IKEY = b"IKEY"	# 
	__slots__=()

#### シェーダプラグイン ----------------
class _ShadT(Chunk_Object.ChunkObject):
	FUNC = b"FUNC"	# 
	__slots__=()

#### ----------------
class _ClipT(Chunk_Object.ChunkObject):
	STIL = b"STIL"	# 静止画
	ISEQ = b"ISEQ"	# シーケンス, prefix:"name" surfix:".ext"に分かれてる.注意
	ANIM = b"ANIM"	# 動画
	XREF = b"XREF"	# リファレンス
	STCC = b"STCC"	# ??
	TIME = b"TIME"	# 有無はISEQ依存？
	CONT = b"CONT"	# コントラスト
	BRIT = b"BRIT"	# 明るさ
	SATR = b"SATR"	# 彩度
	HUE_ = b"HUE "	# 色相
	GAMM = b"GAMM"	# ガンマ
	NEGA = b"NEGA"	# 反転
	IFLT = b"IFLT"	# プラグイン
	PFLT = b"PFLT"	# プラグイン
					# CLIP サブチャンク サイズ2
	CLRS = b"CLRS"	# カラースペースRGB, デフォ:無し Linear:0～, CLRS { type[U4] }
	CLRA = b"CLRA"	# カラースペースAlpha, デフォ:無し Linear:0～, CLRA { type[U4] }
	DITH = b"DITH"	# ディザ デフォ:無し, DITH { mode[U2] }
	FILT = b"FILT"	# HDRオプト デフォ:無し, FILT { mode[U2] }
	FLAG = b"FLAG"	# FLAG { flag[U4] }
					# フラグ詰め デフォ 0x00000080(mipmap)
					# インターレス Even:0x00000008, Odd:0x00000010
					# ミップマップ High:0x00000080, Low:0x00000100
					# マップモード Anti:0,         soft:0x08000000
	__slots__=()

#### ----------------
# [FORM][size][LWO2][TAGS]...
class _ChunkT(Chunk_Object.ChunkObject):
	FORM = b"FORM"
	LWO2 = b"LWO2"	# ファイルヘッダ
	LWO3 = b"LWO3"	# ファイルヘッダ

	OTAG = b"OTAG"	# オブジェクトタグ (3)
	TAGS = b"TAGS"	# タグ文字列
	LAYR = b"LAYR"	# レイヤー
	CLIP = b"CLIP"	# イメージ/シーケンス
	ENVL = b"ENVL"	# エンベロープ
	PNTS = b"PNTS"	# 頂点リスト
	POLS = b"POLS"	# ポリゴンリスト
	PTAG = b"PTAG"	# ポリゴンタグ
	VMAP = b"VMAP"	# 頂点マッピング
	VMAD = b"VMAD"	# 非連続頂点マッピング
	VMPA = b"VMPA"	# 頂点マップパラメータ/線色等 UV補間 0:リニア, 1:サブパッチ, 2:リニアコーナー, 3:リニアエッジ, 4:非連続エッジ
	VMED = b"VMED"	# Modo LWO エッジ
	SURF = b"SURF"	# サーフェス
	BBOX = b"BBOX"	# 
	DESC = b"DESC"	# 
	TEXT = b"TEXT"	# 
	ICON = b"ICON"	# 
	__slots__=()

#### =======================================================================
# str : id
PolyIdT = Chunk_Object.ChunkKeyId("PolyIdT", _PolyT)
VMapIdT = Chunk_Object.ChunkKeyId("VMapIdT", _VMapT)
VMedIdT = Chunk_Object.ChunkKeyId("VMedIdT", _VMedT)
PTagIdT = Chunk_Object.ChunkKeyId("PTagIdT", _PTagT)
SurfIdT = Chunk_Object.ChunkKeyId("SurfIdT", _SurfT)
SBlokIdT= Chunk_Object.ChunkKeyId("SBlokIdT",_SBlokT)
BlokIdT = Chunk_Object.ChunkKeyId("BlokIdT", _BlokT)
TxtrIdT = Chunk_Object.ChunkKeyId("TxtrIdT", _TxtrT)
ImgIdT  = Chunk_Object.ChunkKeyId("ImgIdT",  _ImgT)
ProcIdT = Chunk_Object.ChunkKeyId("ProcIdT", _ProcT)
GradIdT = Chunk_Object.ChunkKeyId("GradIdT", _GradT)
ShadIdT = Chunk_Object.ChunkKeyId("ShadIdT", _ShadT)
ClipIdT = Chunk_Object.ChunkKeyId("ClipIdT", _ClipT)
ChunkIdT= Chunk_Object.ChunkKeyId("ChunkIdT",_ChunkT)
#### ----------------
# id : str
PolyNameT = Chunk_Object.ChunkIdKey("PolyNameT", _PolyT)
"""
VMapNameT = Chunk_Object.ChunkIdKey("VMapNameT", _VMapT)
VMedNameT = Chunk_Object.ChunkIdKey("VMedNameT", _VMedT)
PTagNameT = Chunk_Object.ChunkIdKey("PTagNameT", _PTagT)
SurfNameT = Chunk_Object.ChunkIdKey("SurfNameT", _SurfT)
SBlokNameT= Chunk_Object.ChunkIdKey("SBlokNameT",_SBlokT)
BlokNameT = Chunk_Object.ChunkIdKey("BlokNameT", _BlokT)
TxtrNameT = Chunk_Object.ChunkIdKey("TxtrNameT", _TxtrT)
ImgNameT  = Chunk_Object.ChunkIdKey("ImgNameT",  _ImgT)
ProcNameT = Chunk_Object.ChunkIdKey("ProcNameT", _ProcT)
GradNameT = Chunk_Object.ChunkIdKey("GradNameT", _GradT)
ShadNameT = Chunk_Object.ChunkIdKey("ShadNameT", _ShadT)
"""
ClipNameT = Chunk_Object.ChunkIdKey("ClipNameT", _ClipT)
#ChunkNameT= Chunk_Object.ChunkIdKey("ChunkNameT",_ChunkT)

#### =======================================================================
# enum LWTextureProjection
class TXPRJ(object):
	PLANAR      = 0
	CYLINDRICAL = 1
	SPHERICAL   = 2
	CUBIC       = 3
	FRONT       = 4
	UVMAP       = 5
	sizeof      = 6
	__slots__=()

#enum LWTextureBlendMode
class TXBLN(object):
	NORMAL     = 0
	SUBTRACT   = 1
	DIFFERENCE = 2
	MULTIPLY   = 3
	DIVIDE     = 4
	ALPHA      = 5
	DISPLACE   = 6
	ADD        = 7		# SDK
	PMULTI     = 8
	PSCREEN    = 9
	POVERRAY   = 10
	PSOFT      = 11
	PHARD      = 12
	PCOLDODGE  = 13
	PCOLBURN   = 14
	PDARKEN    = 15
	PLIGHTEN   = 16
	PEXCLUSION = 17
	sizeof     = 18
	__slots__=()

#### =======================================================================
#### 共用
#### =======================================================================
class ReadT(object):
	FORM = ">III"	# lwidを文字でなくintで扱う. >4sL4s
	TAG  = ">I"		# >4s
	LWID = TAG		# 
	TAGU2= ">IH"	# TAGとU2同時. >4sH
	FLAG = ">HH"

	F4   = ">f"
	U4   = ">I"
	U2   = ">H"
	U1   = ">B"
	I4   = ">i"
	I2   = ">h"
	I1   = ">b"
	ANG4 = F4
	U2U2 = ">HH"
	UV   = ">ff"
	OPAC = ">Hf"
	ISEQ = ">BBhHhh"
	VEC4 = ">4f"
	VEC3 = ">3f"
	__slots__=()

#### --------------------------------
class RSize(object):
	FORM = 12	# LWID+U4+LWID
	TAG  = 4
	LWID = 4

	VX   = 4	# 可変長判定する為最大の4
	F4   = 4
	U4   = 4
	U2   = 2
	U1   = 1
	I4   = U4
	I2   = U2
	I1   = U1
	ANG4 = F4
	UV   = F4*2
	OPAC = 6
	ISEQ = 10
	VEC4 = F4*4
	VEC3 = F4*3

	LYRN = U4 + VEC3
	TAGU2= TAG + U2
	U2U2 = U2*2
	FLAG = U4
	__slots__=()
