﻿# -*- coding: utf-8 -*-

from __future__ import absolute_import

from .. import Chunk_Object

#### ========================================================================
__all__ = (
	"EulerRotateOrderT",
#	"RotateOrderT",
	"SFixNM", "SetFMT", "NameFMT", "VType", "NdType", "WgtAttr", "ShdType", "JtSizeT",
	"MorfT", "GrpVisT",
	"MORF_NO_GRP", "DEFAULT_UV", "SHADER_TEMP_NAME", "gMeshDispColrChans", "gShaderTypes",
	)

#### ========================================================================
class EulerRotateOrderT(Chunk_Object.ChunkObject):
	# MEulerRotation
	xyz = 0
	yzx = 1
	zxy = 2
	xzy = 3
	yxz = 4
	zyx = 5
	__slots__=()

"""
class RotateOrderT(Chunk_Object.ChunkObject):
	# MFnTransform.setRotationOrder
	xyz = 1
	xzy = 4
	yxz = 5
	yzx = 2
	zxy = 3
	zyx = 6
	__slots__=()
"""

#### ------------------------------------------------------------------------
class SFixNM(object):
	MTL = "_MT"
	SG  = "_SG"
	FILE = "_file"
	LWCOL = "_LWColr_LT"
	LWBMP = "_LWBump_LT"
	BLSHAPE = "_BS"
	MF_TRS   = "_morf"
	MF_SHAPE = "_morfShape"
	MF_GRP= "_Morph_grp"
	__slots__=()

class SetFMT(object):
	SELS = "SelsSet_{NAME}_"	# 選択sets名format, XXX_{DAG名}_LW名になる
	COLR = "ColrSet_{NAME}_"	#
	PART = "PartSet_{NAME}_"	#
	PICK = "PickSet_{NAME}_"	# lxo
	__slots__=()

class NameFMT(object):
	B2D = "B2D_{NAME}"	# bump2dノード名のformat
	P2D = "P2D_{NAME}"	# place2dノード名のformat
	VCOL= "mrVCol_{NAME}"	# mrVColノード名のformat
	JNTGRP = u"{NAME}_grp"	# jointの根に置く親transformの名称surfix, format()用文字列
	CRVNAME = u"{NAME}_crv"				# 単数時の名称format. 共に"Shape"付与.
	CRVNAMES= u"{NAME}{SPC}{{CNT}}_crv"	# 複数時の名称format, CNTには後から数が入る.
	__slots__=()

class VType(object):
	DBL3 = {"typ":"double3"}
	STR  = {"typ":"string"}
	FLTA = {"typ":"floatArray"}
	__slots__=()

class NdType(object):
	FILE = "file"
	P2D  = "place2dTexture"
	LAYR = "layeredTexture"
	BUMP = "bump2d"
	VCOL = "mentalrayVertexColors"
	MESH = "mesh"
	JNT  = "joint"
	SKN  = "skinCluster"
	__slots__=()

class WgtAttr(object):
	LN = "lwWgts"
	SN = "lww"
	__slots__=()

class ShdType(object):
	LAMB = 0
	BLIN = 1
	PHON = 2
	SURFS= 3
	__slots__=()

class JtSizeT(object):	# Bone表示径
	COEF = 0.2	# vec長への係数
	MIN  = 0.5	# 算定時の最小
	MAX  = 1.0	# 算定時の最大
	__slots__ = ()

class MorfT(object):
	REL = True
	ABS = False
	__slots__=()

class GrpVisT(object):
	SHOW = True
	HIDE = False
	__slots__=()

#### =======================================================================
MORF_NO_GRP = "NoGrp"		# モーフ名がgrp.nameでない場合にgrpに充填する名
DEFAULT_UV = "map1"

SHADER_TEMP_NAME = "LoadLWO_TemporaryShaderName"

gMeshDispColrChans = ("None", "Ambient", "Ambient+Diffuse", "Diffuse", "Specular", "Emission")

gShaderTypes = ("lambert", "blinn", "phong", "standardSurface")
