﻿# -*- coding: utf-8 -*-

import maya.cmds as mc

#### ========================================================================
# cmdsでmergeUVするの場合,selectの発生は避けられない.
# selectは2016?からのuvEditorのautolaodTexコールバックを駆動するが,
# 該当melはバグ持ちで階層違い同名nodeがあるとエラーになる.
def MergeUVs(fullPathName):
	u'''LWOのUV島外縁部はvmap無しがある為,vmadを避けられない.
MfnMesh.assignUVsに先立ってuv値/Indexの整形をしない場合は別途mergeUVしないと外縁が
不連続状態のままになる.'''
#	m = dagp.fullPathName()
	m = fullPathName

	curUV  = mc.polyUVSet(m, q=True, cuv=True)[0]		# カレント保護,array
	for uvn in mc.polyUVSet(m, q=True, auv=True):		# mesh内全UVmap
		uvNum = mc.polyEvaluate(m, uv=True, uvs= uvn)	# uv名はstrを要求
		if(uvNum > 2):	# UVが2以上？ 3点以下はあれな状態.
			mc.polyUVSet(m, uvs= uvn.encode(), cuv=True)	# uv名はstrを要求
			mc.polyMergeUV("{}.map[0:*]".format(m), uvs= uvn, d= 0.0001, ch=False)
			mc.select(cl=True)
	mc.polyUVSet(m, uvs= curUV.encode(), cuv=True)		# カレント復帰,uv名はstrを要求
