﻿# -*- coding: utf-8 -*-

from __future__ import absolute_import

import re

import maya.api.OpenMaya as om2
import maya.cmds as mc

#### =======================================================================
__all__ = ("Make",)

#### ========================================================================
def Make(dagpMesh, trsName, data, prefixFMT, buildedPolIdxs=None, isPnt=True):
	u'''{name:[idx,,,]} 型データ(SelectionSet/PICK,Ptag:COLR)を汎用Setに格納.'''
	FnSC = om2.MFnSingleIndexedComponent()
	FnSt = om2.MFnSet()
	selLst = om2.MSelectionList()	# container 汎用

	componentType = om2.MFn.kMeshVertComponent if(isPnt) else om2.MFn.kMeshPolygonComponent

	selSet_Prefix = prefixFMT.format(NAME= re.sub("_mesh$|_ME$|_Mesh$", "", trsName))

	for (name, arElmIdxs) in data.iteritems():
		if(buildedPolIdxs):
			arElmIdxs = tuple( buildedPolIdxs[idx] for idx in arElmIdxs if(buildedPolIdxs[idx]!=None) )

		if(not arElmIdxs):
			continue

		moCmp = FnSC.create(componentType)		# FnSingle~へset, moCmpがカレントMObj
		FnSC.addElements(om2.MIntArray(arElmIdxs))

		selLst.clear()					# 再利用, 前処理
		selLst.add((dagpMesh, moCmp))	# コンポーネント選択リスト作成

		selSetName = selSet_Prefix + name
		if(mc.objExists(selSetName)):	# 既存sets？
			FnSt.setObject(om2.MSelectionList().add(selSetName).getDependNode(0))	# 既存Setを受け取る
			FnSt.addMembers(selLst)
		else:							# Set作成/適用 // result強制表示2012~20, 消せない.
			oSet = FnSt.create(selLst, FnSt.kNone) # FnSt.kVerticesOnly 頂点縛りだとoutlinerに出ない
			FnSt.setName(selSetName)
			FnSt.setAnnotation("LWO SelectionSet")
