﻿# -*- coding: utf-8 -*-

from __future__ import absolute_import

bl_info = {
	"name": "Lightwave LWO format",
	"author": "Akira Asagi",
	"version": (0, 1, 2),
	"blender": (2, 80, 0),
	"location": "File > Import",
	"description": "Import LWO/LXO",
	"warning": "",
	"wiki_url": "",
	"support": "TESTING",
	"category": "Import-Export"
}

import sys, os

# 配下のmodule内でreload()をかけるか.
DO_RELOAD = os.path.exists(os.path.join(os.path.dirname(__file__), "__DO_RELOAD__"))

DEBUG = 0

if("bpy" in sys.modules):
	if(DO_RELOAD and ("Blender" in locals().keys())):
		import importlib
		importlib.reload(Blender)
	from .Blender import LoadLWO, register, unregister

elif("maya" in sys.modules):
	# Blenderの制約から最上位に文字列としてbl_info={～}が必要, if()で分離やdict()で処理等は不可
	# Mayaでは不要なので消しておく
	del bl_info

	# BuildLWOで参照. api.OpenMaya(om2)を使うか.
	USE_OM2 = 1

	if(DO_RELOAD and ("LoadLWO" in locals().keys())):
		# moduleとして.
		from .Maya import Load_LWO
		if(sys.version_info[0] >= 3):
			import importlib
			importlib.reload(Load_LWO)
		else:
			reload(Load_LWO)
	# moduleからclass
	from .Maya.Load_LWO import LoadLWO

"""
from . import Chunk_Object
from . import DebugPrints
from . import FnCalc
from . import FnRead
from . import LWO_Object
from . import LWO_ParseHeader
from . import LXO_Object
from . import LXO_ParseHeader
from . import Parse_LWO
from . import Parse_LXO
from . import Vis_Flags
"""
